//【登録場所】 全体、レス表示
//【ラベル】 テレビ実況板の勢いポップアップ
//【内容】 テレビ番組欄＠2ch (http://epg.2ch.net/tv2chwiki/pukiwiki.php)から”勢い”と部分をポップアップ表示する。
// ※現在、上記URLでは勢いが0なため、勝手に２ちゃんねるTV実況勢いグラフ (http://tv2ch.nukos.net/tvres.htm)から”勢い”の部分をポップアップ表示する。
//【コマンド1】 $SCRIPT tv.js
//【コマンド2】 $SCRIPT tv.js board　//TV局クリックで板表示
//【コマンド3】 $SCRIPT tv.js thread　//TV局クリックで勢いのあるスレ表示 ※現在利用できません。
//【スクリプト】
//設定
var closeOnMouseExit = true; //カーソルをポップアップ内から外に移動で、そのポップアップを閉じる
var closeOnLinkClick = false; //ポップアップのリンクをクリックで、そのポップアップを閉じる(trueだとサブポップアップ下に「戻る」ボタンが付きます)
var replaceSpeedValue = true; //”勢い”部分を”勝手に２ちゃんねるTV実況勢いグラフ”からの”勢い”に置換する
var useOnlyNukos = false; //”勝手に２ちゃんねるTV実況勢いグラフ”のみを利用する（リンクもなし）
//設定ここまで

var vcx = v2c.context;
var option = vcx.args[0] + '';
var main = '';
vcx.setDefaultCloseOnMouseExit( closeOnMouseExit );

function formSubmitted( u, sm, sd ) {
  if( sd.indexOf( 'return=' ) > -1 ){
    vcx.setPopupHTML( main );
    vcx.setRedirectURL( true );
    vcx.closeOriginalPopup();
  }
}
function isHtml( html, url ) {
  if ( !html ) {
    v2c.alert('ページを取得できませんでした。\n' + url );
    return false;
  }
  return true;
}
function matchRe( arr, url ) {
  if ( !arr ) {
    v2c.alert('抽出できませんでした。\n' + url );
    return false;
  }
  return true;
}
function redirectURL(u) {
  var url = u + '', sr;
  vcx.setRedirectURL( true );
  if ( !closeOnLinkClick ) vcx.setCloseOnLinkClick( false );
//  vcx.setCloseOnLinkClick( true );　//サブポップアップは常にリンククリックで閉じたい場合は上と置換
  if ( url.indexOf('ttp://epg.2ch.net/tvpi/') > -1 ) return u;
  var sh = v2c.readURL( url );
  if ( !isHtml( sh, url ) ) return;
  var rb = closeOnLinkClick ? '<form action=""><input type="submit" value="戻る" name="return"></form>' : '';
//  var rb = '';　//常に「戻る」ボタンはいらない場合は上と置換
  if ( url.indexOf('ttp://epg.2ch.net/subject.cgi?key=') > -1) {
    if ( option == 'board' ){
      if ( !matchRe( sh.match( /板のURL\t<a href="([^>]+?)">/i ), url ) ) return;
      return RegExp.$1;
    } else if ( option == 'thread' ) {
      if ( !matchRe( sh.match( /勢いのあるスレのURL\t<a href="([^>]+?)">/i ), url ) ) return;
      return RegExp.$1;
    } else {
      if ( !matchRe( sh.match( /<pre>([^]+?)\n+?<xmp>/i ), url ) ) return;
      sr = RegExp.$1.replace( /<\/a>/ig, '<\/a>&#13;&#10;<br>' );
      vcx.setPopupHTML( '<html><body style="margin:10px;">' + sr + rb + '</body></html>' );
      if ( closeOnLinkClick ) vcx.setTrapFormSubmission( true );
      return;
    }
  } else if( url.indexOf( 'ttp://epg.2ch.net/subject.cgi?todat=' ) > -1 ) {
    if ( !matchRe( sh.match( new RegExp('勢いのあるスレのURL\\t<a href="([^>]+?)">','i') ), url ) ) return;
    return RegExp.$1;
  } else if( url.indexOf( 'ttp://epg.2ch.net/tv2chwiki/pukiwiki.php?' ) > -1 ) {
    if ( !matchRe( sh.match( /(<table[^]+?<\/table>)/i ), url ) ) return;
    sr = RegExp.$1.replace( /<\/n>/ig, '<\/a>&#13;&#10;' );
    sr = sr.replace( /<div align=\"right\">[^]+?↑edit<\/a><\/div>/ig, '' );
    vcx.setPopupHTML( '<html><body style="margin:10px;">' + sr + rb + '</body></html>' );
    if ( closeOnLinkClick ) vcx.setTrapFormSubmission( true );
    return;
  } else {
    return u;
  }
}
function createPopupString() {
  var epg_url = 'http://epg.2ch.net/tv2chwiki/pukiwiki.php';
  if ( !useOnlyNukos ) {
    var sh = v2c.readURL( epg_url );
    if ( !isHtml( sh, epg_url ) ) return;
    if ( !matchRe( sh.match( /<div id="body">([^]+?)<p>/i ), epg_url ) ) return;
    sh = RegExp.$1.replace( /<br>\n/ig, '&#13;&#10;<br>' );
    v2c.println(sh);
    sh = sh.replace( /href=\"\?/ig, 'href="' + epg_url + '?' );
    sh = sh.replace( '現在放送中のテレビ', '<a href="http://epg.2ch.net/tv2chwiki/pukiwiki.php">現在放送中のテレビ<\a>' );
    if ( !replaceSpeedValue ) main = '<html><body style="margin:5px;">' + sh + '</body></html>';
  }
  if ( useOnlyNukos || replaceSpeedValue ) {
    var tvres_url = 'http://tv2ch.nukos.net/tvres.html';
    var sn = v2c.readURL( tvres_url );
    if ( !isHtml( sn, tvres_url ) ) return;
    if ( !useOnlyNukos ) {
      var dt = sn.match( /<div id="main">\s+<h2>([\d\/ :]+?) 現在\(5分毎更新\)<\/h2>/i );
      if ( !matchRe( dt, tvres_url ) ) return;
      sh = sh.replace( /\d{4}\/\d{2}\/\d{2}\(.\)　[\d: ]+/i, dt[1] );
      var rn = sn.match( /(\d+)(?=\nres\/分)/ig );
      if ( !matchRe( rn, tvres_url ) ) return;
      var n = -1;
      sh = sh.replace( /(\d+)(?=res\/分)/ig, function() { n++; return rn[n]; } );
      main = '<html><body style="margin:5px;">' + sh + '</body></html>';
    } else {
      if ( !matchRe( sn.match( /<h2>(\d+[^]+?)<\/h2>[^]+?(<table [^]+?<\/table>)/i ), tvres_url ) ) return;
      st = RegExp.$1;
      sn = RegExp.$2.replace( /<th.*?\/th>/ig, '' ).replace( /\s/ig, '' ).replace( /<\/td><\/tr>/ig, '\n' ).replace( /<\/td>/ig, ' ' ).replace( /<[^]+?>/ig, '' ).replace( /\n/ig, '<br>' );
      v2c.println(sn);
      //sn = sn.replace( /番組ch\(西日本\)の勢い[^]+/i, '');//「番組ch(西日本)の勢い」以降は表示しない
      main = '<html><body style="margin:5px;"><h2><a href="'+tvres_url+'">現在の勢い</a></h2>' + st + '<br>' + sn + '</body></html>';
    }
  }
  vcx.setPopupHTML( main );
  vcx.setRedirectURL( true );
  vcx.setPopupFocusable( true );
  if ( !closeOnLinkClick ) vcx.setCloseOnLinkClick( false );
}
createPopupString();